// Global variables for project
//
#include <xc.h>
#include "Globals.h"

volatile UINT Timer = 0;	/* 1kHz increment timer */

unsigned char protocol;
unsigned char debuglevel;
unsigned char writeflag;
unsigned char diskno;

void Globals_IO_init(void)
{
    ADCON0 &= ~(1); 		// ADON bit 0, AD converter OFF
    ADCON1 = 0x0F; 			// All ADC pins as digital I/O
    CM1CON0 = 0x07; 		// Comparators OFF
    CM2CON0 = 0x07; 		// Comparators OFF
    //OSCCON = 0; 			// Primary oscillator as clock source
    SSP1ADD = 0x4F;  		// SPI baudrate, 100 kHz ( Fosc/(4*(SSPADD+1)) )

    TRISC = 0;
    TRISC |= (1<<4); //all output except RC4 (SDI)
	CD_TRIS = 1;
	WP_TRIS = 1;
    PORTC = 0;
    //
    // PPS
    //
    SSP1CLKPPS = 0x13;      //RC3->MSSP1:SCK1;    
    RC3PPS = 0x0F;          //RC3->MSSP1:SCK1;    
    RC5PPS = 0x10;          //RC5->MSSP1:SDO1;    
    SSP1DATPPS = 0x14;      //RC4->MSSP1:SDI1;    
}
