// Global data for SD Card
#include <xc.h>
#include "ff.h"
#include "defines.h"
#ifndef GLOBALS_H
#define	GLOBALS_H

#define CD_PORT		PORTCbits.RC1		// Card detect
#define CD_LAT		LATCbits.LATC1
#define CD_TRIS		TRISCbits.TRISC1

#define WP_PORT		PORTCbits.RC2		// Write Protect
#define WP_LAT		LATCbits.LATC2
#define WP_TRIS		TRISCbits.TRISC1

extern volatile UINT Timer;

extern unsigned char protocol;
extern unsigned char debuglevel;
extern unsigned char writeflag;
extern unsigned char diskno;
//

extern char filenames[16+MAXDISK+1][MAXFN]; // Name of LIF image files
extern char cfgfile[];                  // Name of config file
extern FIL File[MAXDISK+1];

extern DWORD MagicVector;

#ifdef	__cplusplus
extern "C" {
#endif

    void Globals_IO_init(void);
    unsigned char Globals_time_to_log(void);

#ifdef	__cplusplus
}
#endif

#endif	/* GLOBALS_H */

