#include <xc.h>
#include "display.h"
#include <stdio.h>
//
// Interface for the NewHaven NHD-C0216CZ-FSW-FBW-3V3 plus
// up to 8 buttons connected to a 4017 counter
// (c) Anders Gustafsson 2020)

// https://www.newhavendisplay.com/specs/NHD-C0216CZ-FSW-FBW-3V3.pdf
//
//int main(void)
//{   
//    char key;;
//    int i=0;
//    int disk = 0;

//    // 
//    init();
//    init();
//        writedata('a');
//        __delay_ms(20);
//        writedata('b');
////        writedata('c');
//    lcd_puts("cde");
//    __delay_ms(1000);
//    while(1)
//    {
//        //
//        key = readkeys();
//        if(key & 0x01) ++disk;
//        if(key & 0x04) --disk;
//        __delay_ms(10);
//        writecom(0x80+0x40);    // Line 2
//        //writedata('#');
//        sprintf(string,"Tick %d btn %X  ", i++, key);
//        lcd_puts(string);
//        //
//        writecom(0x80);    // Line 1
//        sprintf(string,"Disk %d ", disk);
//        lcd_puts(string);
//        CLRWDT();
//    }
//    return 0;
//}
// Initialise the display
void lcd_init(void)
//initialize the LCD
{
    ADCON1 = 0xFF;       // Turn off analogue
    ANSELA = 0;
    ANSELB = 0;
    ANSELC = 0;
    //LCD_RST_TRIS = 0;
    LCD_RS_TRIS = 0;
    LCD_CSB_TRIS = 0;
    LCD_SCL_TRIS = 0;
    LCD_SI_TRIS = 0;
    
    __delay_ms(200);
    //LCD_RST_LAT = 0; //RESET
    __delay_ms(200);
    //LCD_RST_LAT = 1; //end reset
    __delay_ms(20);
    writedata(0x30,0); //wake up
    __delay_ms(2);
    writedata(0x30,0); //wake up
    writedata(0x30,0); //wake up
    writedata(0x39,0); //function set
    writedata(0x14,0); //internal osc frequency
    writedata(0x56,0); //power control
    writedata(0x6D,0); //follower control
    writedata(0x70,0); //contrast
    writedata(0x0C,0); //display on
    writedata(0x06,0); //entry mode
    writedata(0x01,0); //clear
    __delay_ms(10);
}
//// Write a command to the display
//void writecom(char d)
//{
//    int serialcounter;
//    LCD_CSB_LAT = 0;    //CS
//    __delay_us(1);
//    LCD_RS_LAT = 0;     //A0 = Command
//    for(serialcounter = 1; serialcounter <= 8; serialcounter++) //send 8 bits
//    {
//        if((d&0x80)==0x80) //get only the MSB
//            LCD_SI_LAT=1; //if 1, then SI=1
//        else
//            LCD_SI_LAT=0; //if 0, then SI=0
//        d=(d<<1); //shift data byte left
//        LCD_SCL_LAT = 0;
//        LCD_SCL_LAT = 1;
//        LCD_SCL_LAT = 0; //SCL
//    }
//    LCD_CSB_LAT = 1;
//}
// write data to the display, how = 1 is data, 0 is command
void writedata(char d, char how)
{
    int serialcounter;
    LCD_CSB_LAT = 0; //CS
    __delay_us(1);
    LCD_RS_LAT = how; //A0 = Data
    for(serialcounter = 1; serialcounter <= 8; serialcounter++) //send 8 bits
    {
        if((d&0x80) == 0x80) //get only the MSB
            LCD_SI_LAT = 1; //if 1, then SI=1
        else
            LCD_SI_LAT = 0; //if 0, then SI=0
        d=(d<<1); //shift data byte left
        LCD_SCL_LAT = 0;
        LCD_SCL_LAT = 1;
        LCD_SCL_LAT = 0; //SCL
    }
    LCD_CSB_LAT = 1;
}
// write a string to the display
void lcd_puts(char *s)
{
    __delay_ms(1);
        
	while(*s != 0)
	{
        __delay_ms(1);
		writedata(*s, 1);
		++s;
        __delay_ms(1);
	}
}
// Clear to end of line
void lcd_clrln(void)
{
    int i = 16;    
	while(i--)
	{
        //__delay_ms(1);
		writedata(0x20, 1);
	}
}
// Read our buttons. Return is a char with corresponding bit set or clear
// Make the for loop to the last button, no more for efficiency!
char readkeys(void)
{
    int i;
    char mask = 1;
    char key = 0;
    KEY_SENSE_TRIS = 1;
    LCD_CSB_LAT = 1;    // Unaddress LCD
    LCD_RS_LAT = 1;
    __delay_us(1);
    LCD_RS_LAT = 0;     // Reset counter
    __delay_us(1);      // This is the pulse width for the first key
    for(i=0;i<3;i++)
    {
        if(KEY_SENSE_PORT)
            key = key | mask;
        mask = mask << 1;
        LCD_SCL_LAT = 0;
        __delay_us(1);  // This is the pulse width for the following keys
        LCD_SCL_LAT = 1;
        __delay_us(1);
        LCD_SCL_LAT = 0;    //Wiggle clock
    }
    return key;
}
